<template>
    <div class="content__leftAnalitika">
        <div class="settings animated fadeInUp">
            <p class="title-sett">Редактирование</p>
            <form action="" @submit.prevent="save">
                <div class="setting--input">
                    <div class="text-left">{{ tt('name') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <input type="text" v-model="form.name">
                        </div>
                    </div>
                </div>
                <div class="setting--input" v-if="!isBanner">
                    <div class="text-left">{{ tt('deposit') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <input type="text" v-model.number="form.deposit">
                        </div>
                    </div>
                </div>
                <div class="setting--input">
                    <div class="text-left">{{ tt('cost') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <input type="text" v-model.number="form.cost">
                        </div>
                    </div>
                </div>
                <div class="setting--input" v-if="isBanner">
                    <div class="text-left">{{ tt('link') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <input type="text" v-model="form.link">
                        </div>
                    </div>
                </div>
                <div class="setting--input">
                    <div class="text-left">{{ tt('posted_at') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <flat-pickr id="modal_form_posted_at" v-model="form.posted_at" :config="flatpickr_config"/>
                        </div>
                    </div>
                </div>
                <div class="setting--input" v-if="isBanner">
                    <div class="text-left">{{ tt('ended_at') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <flat-pickr id="modal_form_ended_at" v-model="form.ended_at" :config="flatpickr_config"/>
                        </div>
                    </div>
                </div>
                <div class="setting--input" v-if="isBanner">
                    <div class="text-left">{{ tt('user_nick') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <input type="text" v-model="form.user_nick">
                        </div>
                    </div>
                </div>
                <div class="setting--input">
                    <div class="text-left">{{ tt('description') }}</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <textarea v-model="form.description" />
                        </div>
                    </div>
                </div>
                <button type="submit">{{ $t('ui.save') }}</button>
            </form>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import route from "../mixins/route";

    export default {
		name: "PromoEdit",
        mixins: [route],
        props: {
            id: {
                required: true
            },
        },
        data(){
            return {
                promo: undefined,
                form: {
                    type: this.type,
                    name: '',
                    cost: 0,
                    deposit: 0,
                    posted_at: null,
                    ended_at: null,
                    link: '',
                    user_nick: '',
                    description: '',
                },
                flatpickr_config: {
                    enableTime: true,
                    time_24hr: true,
                    dateFormat: "Y-m-d H:i:S",
                }
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
            isBanner(){
                return this.promo && this.promo.type === 'banner';
            },
        },
        methods: {
            tt(key){
                return this.$t(`promos.pages.${this.promo.type}.create.${key}`);
            },
            load(){
                this.axios
                    .get(`promos/${this.id}`)
                    .then(resp => resp.data)
                    .then(promo => this.promo = promo)
                ;
            },
            save(){
                this.axios
                    .post(`promos/${this.id}`, this.form)
                    .then(resp => resp.data)
                    .then(data => {
                        this.$swal(this.$t('ui.success'), data.message, 'success')
                            .then(() => {
                                this.$router.push(this.route('promos'))
                            });
                    })
                ;
            }
        },
        mounted() {
            this.load();
        }
	}
</script>

<style scoped>

</style>
